package com.abacus.improved;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JPanel;
//Maybe make this an interface to implement by zoomable panel?
//TODO: ActionListener makes more sense......
public class ZoomPanel extends JPanel implements MouseListener{
	private JButton scrollUp, scrollDown;
	private JButton scrollLeft, scrollRight;
	private JButton zoomOut, zoomIn;
	public static final Integer ZOOMIN = 2;
	public static final Integer ZOOMOUT = 3;
	public static final Integer SCROLLUP = 4;
	public static final Integer SCROLLDOWN = 5;
	public static final Integer SCROLLLEFT = 6;
	public static final Integer SCROLLRIGHT = 7;
	private Integer currentButtonState;
	
	public ZoomPanel() {
		this.setBackground(new Color(0, 127, 255));
		this.currentButtonState = 1;
		GridBagConstraints c = new GridBagConstraints();
		this.setLayout(new GridBagLayout());
		c.fill = GridBagConstraints.BOTH;
		this.zoomIn = new JButton("Zoom In");
		this.zoomIn.addMouseListener(this);
		c.gridx = 0;
		c.gridy = 0;
		this.add(this.zoomIn, c);
		this.zoomOut = new JButton("Zoom Out");
		this.zoomOut.addMouseListener(this);
		c.gridx = 0;
		c.gridy = 2;
		this.add(this.zoomOut, c);
		this.scrollDown = new JButton("Down");
		this.scrollDown.addMouseListener(this);
		c.gridx = 2;
		c.gridy = 2;
		this.add(this.scrollDown, c);
		this.scrollLeft = new JButton("Left");
		this.scrollLeft.addMouseListener(this);
		c.gridx = 1;
		c.gridy = 1;
		this.add(this.scrollLeft, c);
		this.scrollRight = new JButton("Right");
		scrollRight.addMouseListener(this);
		c.gridx = 3;
		c.gridy = 1;
		this.add(this.scrollRight, c);
		this.scrollUp = new JButton("Up");
		c.gridx = 2;
		c.gridy = 0;
		scrollUp.addMouseListener(this);
		this.add(this.scrollUp, c);
	}
	
	public Integer getZoomState() {
		return this.currentButtonState;
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {}

	@Override
	public void mouseEntered(MouseEvent arg0) {}

	@Override
	public void mouseExited(MouseEvent arg0) { }

	@Override
	public void mousePressed(MouseEvent e) {
		if (e.getSource() == zoomIn) {
			this.currentButtonState = ZoomPanel.ZOOMIN;
		} else if (e.getSource() == zoomOut) {
			this.currentButtonState = ZoomPanel.ZOOMOUT;
		} else if (e.getSource() == scrollUp) {
			this.currentButtonState = ZoomPanel.SCROLLUP;
		} else if (e.getSource() == scrollDown) {
			this.currentButtonState = ZoomPanel.SCROLLDOWN;
		} else if (e.getSource() == scrollLeft) {
			this.currentButtonState = ZoomPanel.SCROLLLEFT;
		} else if (e.getSource() == scrollRight) {
			this.currentButtonState = ZoomPanel.SCROLLRIGHT;
		}
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		this.currentButtonState = 0;
	}
}
